import requests
from urllib.parse import urlparse
import json
import os
from http.server import BaseHTTPRequestHandler
from threading import Thread
from auth_code_flow import FlowManager
from diskcache import Cache
from selenium import webdriver
from selenium.webdriver.common.by import By
import socketserver
import ssl
import requests
from bs4 import BeautifulSoup


def whoami(lc):
    url = "https://testdtu.brightspace.com/d2l/api/lp/1.36/users/whoami"
    payload = {}
    headers = {
        'Authorization': 'Bearer eyJhbGciO...wVQ'
    }
    headers = lc.headers
    response = requests.request("GET", url, headers=headers, data=payload)
    print(response.text)
    return response


class LearnConfig:
    server = "testdtu.brightspace.com/"
    lp_version = "1.36"
    headers = {'Authorization': 'Bearer bla-bla' }
    scope = "content:*:* core:*:*"


    def get_header(self):
        headers = {
            # cc = Cache(directory="cache")
            'Authorization': f"Bearer {self.cc['access_token']}"
        }
        return headers

    def isodate(self, date):
        d = date.isoformat()
        return d.split(".")[0] + ".000Z"

    orgunitId = "8407"
    def is_token_valid(self):
        response = whoami(self)
        json = response.json()
        if "FirstName" in json:
            print("Hello there", json['FirstName'])
            return True
        print("Authentication failed")
        print(json)
        return False


    def _oauth2_refresh(self, username='tuhe', password=None):
        url = "https://auth.brightspace.com/core/connect/token"

        # access_token_url = "https://auth.brightspace.com/core/connect/token"
        # authorize_url = "https://auth.brightspace.com/oauth2/auth"  # "http://api.example.com/oauth/access_token",
        base_url = "https://auth.brightspace.com"
        redirect_uri = 'https://localhost:3434/redirecturi'
        """
        https://auth.brightspace.com/oauth2/auth?response_type=code&client_id=4801a477-11c7-4cfc-8732-736f041578be&scope=core%3A*%3A*&redirect_uri=https%3A%2F%2Flocalhost%3A3434%2Fredirecturi
         http://auth.brightspace.com/oauth2/auth?client_id=4801a477-11c7-4cfc-8732-736f041578be&redirect_uri=https%3A%2F%2Flocalhost%3A3434%2Fredirecturi&response_type=code&scope=core%3A%2A%3A%2A&state=my_state
        """
        from unlearn.secrets import client_secret, client_id


        se_flow_manager = FlowManager(
            base_uri=base_url,
            client_id=client_id,
            client_secret=client_secret,  # "your client secret",  # please read this from env vars for security
            redirect_uri=redirect_uri,
            scope=self.scope,
            access_token_path="/core/connect/token",
            authorization_path="/oauth2/auth",
            response_type='code',
        )
        ll = start_localhost(se_flow_manager)

        state = "my_state"
        se_auth_url = se_flow_manager.get_authorization_endpoint(state)
        print(se_auth_url)

        print("Making driver...")
        driver = webdriver.Firefox()
        print("Getting url...")
        driver.get(se_auth_url)
        usernane = driver.find_element(By.ID, "userName")
        usernane.send_keys(username)
        if password is None:
            password = input(f'Please provide password for {username=}')

        fpassword = driver.find_element(By.ID, "password")
        fpassword.send_keys(password)

        button = driver.find_element(By.TAG_NAME, "button")
        button.click()
        print("> Code obtained from server", S.CODE)
        # lc = LearnConfig(refresh_token=S.CODE)
        code = S.CODE
        ll.shutdown()
        print("Code obtained is", code)
        resp = se_flow_manager.fetch_access_token(code, state, post_form_data=True)
        resp_json = resp.json()
        access_token = resp_json['access_token']
        refresh_token = resp_json['refresh_token']
        print("Obtained tokens through login: ")
        print(f"> {access_token=}")
        print(f"> {refresh_token=}")
        self.cc['access_token'] = access_token
        self.cc['refresh_token'] = refresh_token
        print("Checking if valid...")
        # Check if valid:
        self.is_token_valid()
        print("All done!")

    def formaturl(self, url, **kwargs):
        # url = "/d2l/api/bas/(version)/orgunits/(orgUnitId)/classlist/"
        url = f"https://{self.server}{url[1:]}"
        url = url.replace("(version)", self.lp_version)
        url = url.replace("(orgUnitId)", self.orgunitId)
        for k, v in kwargs.items():
            url = url.replace(f"({k})", str(v))

        # print("Brightspace url: ", url)
        return url


    def GET(self, url, data=None):
        if "(" in url or ")" in url:
            print("Url was bad", url)
            assert False
        if data is None:
            data = {}
        print(f"LearnConfig-GET> {url=}")
        print(f"LearnConfig-GET> {data=}")

        response = requests.request("GET", url,
                                    headers=self.headers,
                                    params=data)
        print(f"LearnConfig-GET> {response=}")

        return response

    def __init__(self, refresh_token=None, password=None, clear_tokens=False):
        cc = Cache(directory=      os.path.join( os.path.dirname(__file__), "cache") )
        from unlearn.secrets import client_secret, client_id
        self.client_secret = client_secret
        self.client_id = client_id
        # clear_tokens = True
        if clear_tokens:
            if "refresh_token" in cc:
                del cc['refresh_token']
            if "access_token" in cc:
                del cc['access_token']
        # if "access_token" in cc:
        #     del cc['access_token']

        self.cc = cc
        # if refresh_token is not None:
        #     cc['refresh_token'] = refresh_token
        while True:
            if "access_token" in cc:
                print("is there")
                # Try to connect...
                self.token = cc.get("access_token")
                self.headers['Authorization'] = f"Bearer {self.token}"
                if self.is_token_valid():
                    print("Got a valid token!")
                    a = 234
                    break
                else:
                    del cc['access_token']
                    print("The token sucks.")
                    continue

            else:
                if "refresh_token" in cc:
                    url = "https://auth.brightspace.com/core/connect/token"
                    print("Getting refresh token using", refresh_token)
                    refresh_token = cc['refresh_token']
                    # refresh_token = "rt.eu-wefI"
                    # self.client_id = "48"
                    # self.client_secret = "niL_8"
                    import urllib.parse

                    # scope = urllib.parse.quote(self.scope)
                    # 'Hell%C3%B6%20W%C3%B6rld%40Python'
                    scope = self.scope
                    scope = scope.replace(":", '%3A').replace(" ", '%20')
                    print(scope)

                    #                   core%3A*%3A*
                    # content%3A*%3A*%20core%3A*%3A*
                    #                     payload=f'grant_type=refresh_token&refresh_token={refresh_token}&client_id={self.client_id}&client_secret={self.client_secret}&scope=core%3A*%3A*'
                    payload=f'grant_type=refresh_token&refresh_token={refresh_token}&client_id={self.client_id}&client_secret={self.client_secret}&scope={scope}'

                    headers = {'Content-Type': 'application/x-www-form-urlencoded' }
                    response = requests.request("POST", url, headers=headers, data=payload)
                    print(response.json())
                    cc['refresh_token'] = response.json()['refresh_token']
                    cc['access_token'] = response.json()['access_token']
                    self.is_token_valid()
                    print("Authentication success.")
                    break
                else:
                    # Do oauth2 refreshing...
                    self._oauth2_refresh(password=password)
                    # s = input("Please give me a refresh token")
                    # cc['refresh_token'] = s
                    # print("Saved refresh token", s)
                print("no it is not there")
        print("Phew! Authentication completed.")


class S(BaseHTTPRequestHandler):
    def _set_headers(self):
        self.send_response(200)
        self.send_header("Content-type", "text/html")
        self.end_headers()

    def _html(self, message):
        """This just generates an HTML document that includes `message`
        in the body. Override, or re-write this do do more interesting stuff.
        """
        content = f"<html><body><h1>{message}</h1></body></html>"
        return content.encode("utf8")  # NOTE: must return a bytes object!

    def do_GET(self):
        self._set_headers()
        query = urlparse(self.path)
        print("HANDLING GET QUERY", query)
        # print("query.query is", query.query)
        # print()

        qq = query.query
        print(f"{qq=}")
        if len(qq) == 0:
            print("Query is empty, returning...")
            return
        sq = qq.split('=')
        print(sq)
        sq1 = sq[1]
        print("sq[1]", sq1)
        sq2 = sq1.split('&')
        print(sq2)
        code = sq2[0]
        print("ciode is", code)
        S.CODE = code
        self.wfile.write(self._html(f"url: {self.path}<br>Code was: {code}"))

    def do_HEAD(self):
        self._set_headers()

    def do_POST(self):
        # Doesn't do anything with posted data
        self._set_headers()
        self.wfile.write(self._html("POST!"))

class LocalListen(Thread):
    def shutdown(self):
        print("> localhost: stopping https server...")
        self.httpd.shutdown()
        print("> localhost: stopped.")

    def run(self):
        print("hello world")
        PORT = 3434
        with socketserver.TCPServer(("localhost", PORT), S) as httpd:
            httpd.socket = ssl.wrap_socket(httpd.socket, certfile=os.path.join(os.path.dirname(__file__), 'server.pem'), server_side=True)
            print("> localhost: serving at port", PORT)
            print(httpd.server_address)
            self.httpd = httpd
            httpd.serve_forever()
            print("> localhost: Stopping...")


def start_localhost(flow_manager=None):
    S.flow_manager = flow_manager
    ll = LocalListen()
    ll.start()
    return ll

if __name__ == '__main__':
    print("Hello world")
    lc = LearnConfig()
    ll = LocalListen()
    ll.start()
    ll.httpd.shutdown()


    user = 'tuhe'

    psw = '...'

    params = {'client_id': "4801abe",
              'redirect_uri': "https://localhost:3434/redirecturi",
              'response_type': "code",
              'force_login': "1",
              'scope': 'core:*:*',
              'client_secret': 'niLX8'}

    url = 'https://auth.brightspace.com/oauth2/auth'
    token_url = 'https://auth.brightspace.com/core/connect/token'



    driver = webdriver.Firefox()

    with requests.session() as s:
        OAuth_AccessRequest = s.get(url, params=params)

    driver.get(OAuth_AccessRequest.url)
    # username = driver.find_element(by="id",value="userName")
    # password = driver.find_element(by="id", value="password")
    # button = driver.find_element(by="type", value="button")
    usernane = driver.find_element(By.ID, "userName")
    usernane.send_keys("tuhe")

    password = driver.find_element(By.ID, "password")
    password.send_keys("..")

    # submit = driver.find_element(By.ID, "formId")
    # submit.submit()

    button = driver.find_element(By.TAG_NAME, "button")
    button.click()

    print("Clicked, seeeing what happens next.")

    button = driver.find_element(by="type", value="button")

