import datetime
import json
import requests
from learn_config import LearnConfig

def get_calendar_events(lc):
    """ https://{{server}}d2l/api/le/{{lp_version}}/{{orgunitId}}/calendar/events/ """
    # def whoami(lc):
    url = f"https://{lc.server}d2l/api/le/{lc.lp_version}/{lc.orgunitId}/calendar/events/"
    payload = {}
    response = requests.request("GET", url, headers=lc.headers, data=payload)
    print(response.text)
    return response


def put_calendar_event(lc, start_date, end_date, title="Lecture", description="Do some stuff today", location_name="Auditorim 666"):
    """
    [{'CalendarEventId': 131048,
  'OrgUnitId': 8407,
  'CreatorUserId': 3397,
  'Title': 'This even is a lecture! feel free to drop dead. ',
  'Description': 'Oy veh.',
  'CalendarEventViewUrl': 'https://testdtu.brightspace.com/d2l/le/calendar/8407/event/146759/detailsview',
  'IsAllDayEvent': False,
  'GroupId': None,
  'StartDateTime': '2022-10-26T23:00:00.000Z',
  'EndDateTime': '2022-10-27T01:00:00.000Z',
  'IsRecurring': False,
  'RecurrenceInfo': None,
  'StartDay': None,
  'EndDay': None,
  'LocationId': None,
  'LocationName': 'Auditorium',
  'OrgUnitName': 'Tue Herlau- Sandbox',
  'OrgUnitCode': 'OFFERING-SANDBOX-92378',
  'IsAssociatedWithEntity': False,
  'AssociatedEntity': None,
  'HasVisibilityRestrictions': False,
  'VisibilityRestrictions': {'Type': 1,
   'Range': None,
   'HiddenRangeUnitType': None,
   'StartDate': None,
   'EndDate': None},
  'Presenters': []}]
    """



    url = f"https://testdtu.brightspace.com/d2l/api/le/{lc.lp_version}/{lc.orgunitId}/calendar/event/"

    payload = json.dumps({
        "Title": title, # "Today's Special 666b",
        "Description": description, # "<p>Soup <b>is relly good</p><p>and also healthy</p>",
        "StartDateTime":     lc.isodate(start_date), # "2019-05-02T20:00:00.000Z",
        "EndDateTime":   lc.isodate(end_date), # "2019-05-02T20:30:00.000Z",
        "StartDay": None,
        "EndDay": None,
        "GroupId": None,
        "RecurrenceInfo": None,
        "LocationId": None,
        "LocationName": location_name,
        "AssociatedEntity": None,
        "VisibilityRestrictions": {
            "Type": 1,
            "Range": None,
            "HiddenRangeUnitType": None,
            "StartDate": None,
            "EndDate": None
        }
    })
    headers = lc.get_header()
    headers['Content-Type'] = 'application/json'
    response = requests.request("POST", url, headers=headers, data=payload)
    print(response.text)


def formaturl(lc, url, **kwargs):
    # url = "/d2l/api/bas/(version)/orgunits/(orgUnitId)/classlist/"
    url = f"https://{lc.server}{url[1:]}"
    url = url.replace("(version)", lc.lp_version)
    url = url.replace("(orgUnitId)", lc.orgunitId)
    for k, v in kwargs.items():
        url = url.replace(f"({k})", str(v))

    print("Brightspace url: ", url)
    return url

    # / d2l / api / bas / (version) / orgunits / (orgUnitId) / classlist /


def get_users_lists(lc):
    url = "/d2l/api/le/(version)/(orgUnitId)/classlist/"
    url = formaturl(lc, url)

    # url = formaturl(lc, "/d2l/api/bas/(version)/orgunits/(orgUnitId)/classlist/")
    print("url is", url)
    payload = {}
    response = requests.request("GET", url, headers=lc.headers, data=payload)
    print(response.text)
    print(response)
    return response.json()

    a = 234
    pass

def get_modules(lc):
    url = "/d2l/api/le/(version)/(orgUnitId)/content/root/"
    url = formaturl(lc, url)

    payload = {}
    response = requests.request("GET", url, headers=lc.headers, data=payload)
    print(response)
    return response.json()
    a = 234


def get_contents(lc):
    url = "/d2l/api/le/(version)/(orgUnitId)/content/toc"
    # url = "/d2l/api/lp/(version)/collection/(objectId)/contents/"
    url = formaturl(lc, url)
    get_modules(lc)
    payload = {}
    response = requests.request("GET", url, headers=lc.headers, data=payload)
    # / d2l / api / le / (version) / (orgUnitId) / content / toc
    return response.json()

def get_content_root(lc):
    url = "/d2l/api/le/(version)/(orgUnitId)/content/root/"
    url = formaturl(lc, url)
    payload = {}
    response = requests.request("GET", url, headers=lc.headers, data=payload)
    return response.json()

def get_progress(lc):
    """
    /d2l/api/le/(version)/(orgUnitId)/content/userprogress/
    """
    # url = f"https://{lc.server}d2l/api/le/{lc.lp_version}/{lc.orgunitId}/content/userprogress/"
    url = "/d2l/api/le/(version)/(orgUnitId)/content/userprogress/"
    url2 = "/d2l/api/le/(version)/(orgUnitId)/content/userprogress/"
    url = formaturl(lc, url)

    print(url)
    # url = f"https://{lc.server}d2l/api/le/{lc.lp_version}/{lc.orgunitId}/calendar/events/"
    payload = {}
    # contents = get_contents(lc)
    modules = get_modules(lc)
    users = get_users_lists(lc)
    toc = get_contents(lc)

    mod_id = modules[0]['Id']
    mod_id = modules[0]['Structure'][0]['Id']

    # url = "/d2l/api/le/(version)/(orgUnitId)/content/userprogress/(topicId)"
    topics = get_content_root(lc)
    mod_id = topics[0]['Id']
    # url = formaturl(lc, url).replace("(topicId)", str(mod_id))
    # print(url)

    topic_id = topics[0]['Id']
    # topic_id = 431617
    # url = "/d2l/api/le/(version)/(orgUnitId)/content/topics/(topicId)"
    # url = formaturl(lc, url, topicId=topic_id)

    print(url)

    payload = {'userId': int(users[0]['Identifier']), 'objectId': topic_id}
    # payload = {'userId': int(users[0]['Identifier']) }
    print("payload", payload)
    # payload = {}

    r = lc.GET(lc.formaturl("/d2l/api/le/(version)/(orgUnitId)/content/toc"))
    real_topic_id = r.json()['Modules'][0]['Modules'][0]['Topics'][0]['TopicId']

    r = lc.GET(formaturl(lc, "/d2l/api/le/(version)/(orgUnitId)/content/topics/(topicId)/completions/", topicId=real_topic_id))


    lc.GET(formaturl(lc, "/d2l/api/le/(version)/(orgUnitId)/content/userprogress/"), {'userId': int(users[1]['Identifier']), 'objectId': mod_id})



    lc.GET(formaturl(lc, "/d2l/api/le/(version)/(orgUnitId)/content/userprogress/"), {'userId': int(users[1]['Identifier']), 'objectId': topic_id})
    lc.GET(formaturl(lc, "/d2l/api/le/(version)/(orgUnitId)/content/userprogress/"), {'userId': int(users[1]['Identifier']), 'objectId': topic_id})




    r = lc.GET(formaturl(lc, "/d2l/api/le/(version)/(orgUnitId)/content/userprogress/(topicId)", topicId=topic_id), {'userId': int(users[1]['Identifier'])} )
    lc.GET(lc.formaturl("/d2l/api/le/(version)/locales/"))


    r2 = lc.GET(formaturl(lc, "/d2l/api/le/(version)/content/completions/(userId)/", userId=int(users[0]['Identifier'])), {} )

    user_id = int(users[1]['Identifier'])
    mod_id = modules[0]['Id']

    ids = [431617, 431616, 431620, 431619, 431618, 431621]
    for id in ids:
        r3 = lc.GET(formaturl(lc, "/d2l/api/le/(version)/(orgUnitId)/content/userprogress/"),
                    dict(userId=user_id,  objectId=str(id)))
        print(r3)

    u = "31054"
    u = int(u)
    r3 = lc.GET(formaturl(lc, "/d2l/api/le/(version)/(orgUnitId)/content/completions/"), dict(userIdsCSV=u,ignoreInvalid=True) )
    r4 =lc.GET(formaturl(lc, "/d2l/api/le/(version)/(orgUnitId)/content/completions/mycount/"), dict(level=3))




    print(r4.json())


    print(response.text)
    print(response)
    a = 234


if __name__ == '__main__':
    lc = LearnConfig(clear_tokens=False)
    # users = get_users_lists(lc)
    progress = get_progress(lc)
    get_calendar_events(lc)
    from datetime import datetime, timedelta
    put_calendar_event(lc, start_date=datetime.now(), end_date=datetime.now() + timedelta(hours=2), title="Do stuff for lecture 4", description="<p><b>MORE</b></p>", location_name="Room 022")


